package com.tutego.insel.solutions.radio.v3;
public class Radio
{
	public static final int FM = 1;
	public static final int AM = 0;
	
	private int lautstärke = 0;
	private int band = FM;
	private double frequenz = 0.0;
	private boolean eingeschaltet = false;
	
	public void setzeBand( int band )
	{
		if ((band == FM) || (band == AM))
			this.band = band;
		else
			System.out.println("Falsches Band !");
	}
	
	public int getBand()
	{
		return band;
	}
	
	public double getFrequenz()
	{
		return frequenz;
	}
	
	void waehleSender( double newFrequenz )
	{
		if (eingeschaltet)
			frequenz = newFrequenz;
	}
	
	void volume( int x )
	{
		if (eingeschaltet)
		{
			lautstärke += x;
			if ( lautstärke > 100 ) lautstärke = 100;
			if ( lautstärke < 0 ) lautstärke = 0;
		}
	}
	
	void lauter()
	{
		volume(1);
	}
	
	void leiser()
	{
		volume(-1);
	}
	
	void an()
	{
		eingeschaltet = true;
	}
	
	void aus()
	{
		eingeschaltet = false;
	}
	
	boolean istAn()
	{
		return eingeschaltet;
	}
	
	@Override
  public String toString()
	{
		return "Radio: Sender = " + frequenz +
			" Lautstaerke = " + lautstärke +
			" " + (eingeschaltet ?  "Radio ist an." : "Radio ist aus.");
	}
}
