public class WebCatch
{

	private String sUrl    = "";
	private int    iDepth  = 1;
	private String defPath = "c:/webcatch/";

	public static void main(String args[])  {

		URLExplorer ue;
		
		//create an instance of the main class 
		WebCatch    wc = new WebCatch();;

		//parse the arguments on the command line
//		if (! wc.parseArgs(args))
//			System.exit(0);

		//start the web explorer
//		ue = new URLExplorer(wc.startURL(), wc.depth(), wc.defaultPath());

    ue = new URLExplorer( "http://www.wad.org/daec/auswahl.html", 3, "c:\\temp\\" );
	}

	public String startURL() {
		return sUrl;
	}

	public int depth() {
		return iDepth;
	}

	public String defaultPath() {
		return defPath;
	}

	private boolean parseArgs(String args[]) {

		final char dash  = '-';
		final char slash = '/';
		
		boolean ret   = false;
		boolean error = false;
		String   arg = "";
		int  l = args.length;
		int  i = 0;

		Integer depth;

		if (l==0) {
			printHelpMsg();
			return ret;
		}

		while (i<l && ! error) {
			if (args[i].charAt(0) == dash ||
				args[i].charAt(0) == slash) {

				arg = args[i].toLowerCase();

				switch (arg.charAt(1)) {
				case 'd' :
					try {
						depth = new Integer(arg.substring(2));
						iDepth = depth.intValue();
					}
					catch(NumberFormatException e) {
						System.out.println("You must enter a decimal number after the -d option");
						error = true;
					}
					break;
				case 'p' :
					defPath = arg.substring(2);
					
					//replace DOS backslash by a slash
					defPath.replace('\\', '/');
					
					//ensure the pathname ends with a slash
					if (defPath.charAt(defPath.length()-1) != '/')
						defPath += "/";
					break;
				case '?' :
					printHelpMsg();	
					break;
				case 'h' :
					if (arg.substring(1).equalsIgnoreCase("help"))
						printHelpMsg();
					break;					
				default:
					printHelpMsg();
					error = true;
					break;
				}
			}
			else
				if (sUrl.equals("")) {
					sUrl = args[i];
					ret = true;
				}

			i++;
		}
	
		return ret;
	}

	private void printHelpMsg() {
		System.out.println("Usage :\njava URLCatch [-dn -pd -?] url_name");
		System.out.println("url_name\n     must be a correct URL");
		System.out.println("-dn\n     explore n level below, default is 1");
		System.out.println("-pd\n     store the retrieved files in d");
		System.out.println("     d must be a full directory name, default is c:/webcatch/");
		System.out.println("-?\n      print this help message");
	}
